module Data.Query exposing (..)

import Dict exposing (Dict)
import Dict.Extra exposing (groupBy)
import Data.DataLoader exposing (Entry)
import Statistics

sumTotalVisasIssued : List Entry -> Float
sumTotalVisasIssued entries =
    entries
        |> List.map (.totalVisasIssued >> Maybe.withDefault 0)
        |> List.sum

stdTotalVisasIssued : List Entry -> Float
stdTotalVisasIssued entries =
    entries
        |> List.map (.totalVisasIssued >> Maybe.withDefault 0)
        |> Statistics.deviation
        |> Maybe.withDefault 0

sumTotalVisasApplied : List Entry -> Float
sumTotalVisasApplied entries =
    entries
        |> List.map (.totalVisasApplied >> Maybe.withDefault 0)
        |> List.sum

sumTotalIssuedMEV : List Entry -> Float
sumTotalIssuedMEV entries =
    entries
        |> List.map (.totalIssuedMEV >> Maybe.withDefault 0)
        |> List.sum

groupBySchengen : List Entry -> Dict String (List Entry)
groupBySchengen entries =
    groupBy .state entries

groupByConsulateCountry : List Entry -> Dict String (List Entry)
groupByConsulateCountry entries =
    groupBy .consulateCountry entries